#!/usr/bin/env python
#
# grib_checker.py checks Checks whatever you want to check in your life
#
# AUTHOR: BSC-CNS I. CERNICHARO
#

import requests
import json
import datetime

cds_url = 'https://cds.climate.copernicus.eu/api/v2.ui/resources'
response1 = requests.get(cds_url).json()

response_lvl1 = []
for item in response1:
    response_lvl1.append(cds_url+'/'+str(item))
print
dict_datasets = {}
for i,element in enumerate(response_lvl1):
    print
    print "---------------------------------------------------------------------"
    print
    print "Requesting"
    print "  >Index %s %s" %(i,element)
    print
    ap = requests.get(element).json()
    #dict_d = {}
    if "form" in ap and ap["form"] != None:
        counter = 0
        print
        print ">Dataset Name:",ap["name"]
        dict_var = {}
        for item in ap["form"]:
            print
            print "    @List element index ",counter
            if "dict" in str(type(item)):
                if 1:
                    for e in item.keys():
                        if e == "details":
                            print
                            print "        **",e
                            for op in item[e].keys():
                                if "dict" in str(type(item[e][op])):
                                    #dict_var.update({op:item[e][op]})
                                    print
                                    print "          d***",op,":"
                                    for aj in item[e][op].keys():
                                        print
                                        print "           ****",aj,":"
                                        print "                 ",item[e][op][aj]
                                elif "list" in str(type(item[e][op])):
                                    if op == "values": 
                                        dict_var.update({item["label"]:item[e][op]})
                                    print
                                    print "          l***",op,":"
                                    if op == "groups" and "groups" in item[e].keys():
                                        more_vars = {}
                                        for aj in item[e][op]:
                                            print
                                            print "           ****",aj["label"]
                                            for otk in aj["values"]:
                                                print "             ******",otk
                                            more_vars.update({aj["label"]:aj["values"]})
                                        dict_var.update({"group":more_vars})
                                    else:
                                        for aj in item[e][op]:
                                            if op != "groups":
                                                print
                                                print "           ****",aj
                                    
                                else:
                                    print
                                    print "          ***",op,":",item[e][op]
                        else:
                            print
                            print "        **",e,":",item[e]
                else:
                    print
                    print "        *>",item["label"]
            else:
                print "        **",item
            print
            counter += 1
        dict_datasets.update({ap["name"]:dict_var})
    else:
        dict_datasets.update({ap["name"]:ap})
        print("    @No readeable form")

filename = 'cds_metadata_'+str(datetime.datetime.now().date().isoformat().replace("-",""))+'.json'
print
print 'Saving as %s file' %filename
print
with open(filename, 'w') as fp:
    json.dump(dict_datasets,fp,indent=4,sort_keys=True)
fp.close()
print
print("FINISHED")
print